(function ($) {
    /*****************************************************************
     * System
     * Constructor
     *****************************************************************/
    function Notebooks(place, params) {
        params = $.extend(
            true,
            {},
            {
                config: {
                    general: {
                        lang: "en-US",
                        uilang: "en",
                        version: 2015.0227
                    },
                    dialogHeight:function(){return Math.floor(window.outerHeight*0.8)},
                    dialogWidth:function() {return Math.max(600, Math.floor(window.outerWidth*0.8))}
                },
                neededPlugins:[
                    "notebook","reader"
                ],
                CSSrules:[
                    {"element":".removeActive .applicationButton.addnotebook",
                    "rules":"display: none;"},
                    {"element":" .notebookselection",
                    "rules":"display: flex;margin-top: 1em;  flex-wrap: wrap;min-width:150px;"},
                    {"element":".removeActive .notebookselection .notebookSelector:before",
                    "rules":"content:\"X\";width:15px;height:15px;border:1px solid black;border-radius:10px;padding:5px;background-color:red;color:white;font-weight:bold;position: absolute;margin-left: 4.5em;"},
                    {"element":".notebooks",
                    "rules":"min-width:300px;"},
                    {"element":" .notebookSelector:hover",
                    "rules":"box-shadow:5px 5px 5px #999,-5px -5px 5px #999;"},
                    {"element":" .notebookSelector",
                    "rules":"cursor:pointer;background-color:white;border:1px solid gray;padding:0.2em;border-radius:5px;min-height:100px;min-width:100px;display:inline-block;margin-left:1em; margin-bottom:1em;"},
                    {"element":" .notebookSelector .bookname",
                    "rules":"overflow: hidden; min-width: 90px; min-height: 90px; text-overflow: ellipsis; display: inline-block;"}
                ],
                applicationType:"notebooks",
                applicationcontentpath : "own_notes",
                contexttype : "own_notes",
                defaultnew:{
                    type: 'book',
                    metadata: {

                    },
                    data: {
                        bookid: '',
                        title: {
                            common: 'Notebook'
                        },
                        toc:
                            {
                                type:"toc",
                                metadata:{},
                                data:{
                                    firstpage: {

                                    }
                                }

                            },
                        pagetitles: {
                            common: {}
                        },
                        content: {}
                    }
                },
                translations:{
                    "en":{
                        "Notebooks:notebook":"Notebook",
                        "Notebooks:serverimport":"Import notebook from server",
                        "Notebooks:addnewnotebook":"Add new notebook",
                        "Notebooks:notebookstitle":"Notebook title",
                        "Notebooks:addnotebook":"Add notebook",
                        "Notebooks:print_page": "Print page",
                        "Notebooks:save": "Save",
                        "Notebooks:file": "File",
                        "Notebooks:opentutorial": "Learn to use a notebook",
                        "Notebooks:opencheckertutorial": "Learn to use the automatic checker"
                    },
                    "sv":{
                        "Notebooks:notebook":"Häfte",
                        "Notebooks:serverimport":"Hämta häftet från servern",
                        "Notebooks:addnewnotebook":"Lägg till ett nytt häfte",
                        "Notebooks:notebookstitle":"Häftets namn",
                        "Notebooks:addnotebook":"Lägg till ett nytt häfte",
                        "Notebooks:print_page": "Skriv ut sida",
                        "Notebooks:save": "Spara",
                        "Notebooks:file": "Fil",
                        "Notebooks:opentutorial": "Lär dig använda häften",
                        "Notebooks:opencheckertutorial": "Lär dig använda den automatiska checkern"
                    },
                    "fi":{
                        "Notebooks:notebook":"Vihko",
                        "Notebooks:serverimport":"Tuo vihko palvelimelta",
                        "Notebooks:addnewnotebook":"Lisää uusi vihko",
                        "Notebooks:notebookstitle":"Vihkon nimi",
                        "Notebooks:addnotebook":"Lisää vihko",
                        "Notebooks:print_page": "Tulosta sivu",
                        "Notebooks:save": "Tallenna",
                        "Notebooks:file": "Tiedosto",
                        "Notebooks:opentutorial": "Opi vihon käyttö",
                        "Notebooks:opencheckertutorial": "Opi tarkistimen käyttö"
                    }
                }//TODO: read tranlations from file
            },
            params
        );
        application.call(this, place, params);
    }
    //Inherit from application
    Notebooks.prototype = Object.create(application.prototype);
    Notebooks.prototype.constructor = Notebooks;
    Notebooks.prototype.parentClass = application.prototype;
    Notebooks.prototype.eventHandlerInitParent = Notebooks.prototype.eventHandlerInit;
    Notebooks.prototype.mainParent = Notebooks.prototype.main;
    /******
     * Event handlers
     ******/
    Notebooks.prototype.eventHandlerInit = function() {
        this.eventHandlerInitParent();
        var notebookSelf = this;
        this.place.on('openBook.notebooks', function(e,data) {
            console.log(JSON.stringify(jQuery(this)[0]));
        });
        this.place.off('pluginsAvailable.notebooks').on('pluginsAvailable.notebooks', function(e,data) {
            if (data.pluginsAvailable){
                notebookSelf.place.trigger('getAvailableContent.system', {path: "own_notes", event: "availableBooks.notebooks"});
            } else {
                notebookSelf.getMissingPlugin(data.missing || notebookSelf.neededPlugins);
            };
        });
        this.place.off('click', '.notebookSelector:not(.editname)').on('click', '.notebookSelector:not(.editname)', function(e, data) {
            var contextid = jQuery(this).attr('fileRef').replace(/\.json$/, '');
            if (notebookSelf.place.hasClass('removeActive')){
                if (jQuery(this).hasClass('contextOpen'))return true;
                if (confirm(notebookSelf.config.localizer.localize('system:remove_element_confirm'))){
                    notebookSelf.place.trigger("systemrequest.system", {
                        type:"removeContent" ,
                        removeFile : {"content": "own_notes", "contextid": (jQuery(this).attr("contextid") ? jQuery(this).attr("contextid") : jQuery(this).attr("fileRef")),"contenttype":"own_notes","contexttype":"own_notes"},
                        callbackEvent: "refreshview.notebooks",
                        callbacktype: "jQuery"
                    });
                }
            } else {
                notebookSelf.openNotebook(contextid);
            };
        });
        this.place.off('availableBooks.notebooks').on('availableBooks.notebooks', function(e, data) {
            if(!data.contentList || data.contentList.length===0){
                notebookSelf.books = [];
                notebookSelf.place.append('<span class="noContent">No books available</span>');
                notebookSelf.place.trigger('initialized.notebooks');
            } else {
                notebookSelf.books = data.contentList;
                notebookSelf.place.trigger('getAvailableViews.system',{event:"availableViews.notebooks"});
            };
        });
        this.place.off('availableViews.notebooks').on('availableViews.notebooks', function(e, data) {
            notebookSelf.place.find('.contentselection').remove();
            notebookSelf.place.find('.appControlarea .controlpanel').empty();
            var appendPlace = notebookSelf.place.append("<div class=\"notebookselection contentselection\"></div>").find(".notebookselection");
            for (var bookFile in notebookSelf.books){
                notebookSelf.addBookSelector(notebookSelf.books[bookFile],appendPlace);
            };
            notebookSelf.place.trigger('initialized.notebooks');
            notebookSelf.place.trigger(
                'notify.system',
                {msg: "notebooksDone", type: "notification"}
            );
        });
        this.place.off('click.addnotebook').on('click.addnotebook','.addnotebook,.contentSelector.newcontentSelector', function() {
            notebookSelf.place.trigger('newContentinfo.system', {
                contenttype: "own_notes",
                contexttype: "own_notes",
                includelocal: true,
                filetype: "json",
                event: 'addnotebookinit.ready',
                includeserverdata: true,
                servercontenttype: "own_notes",
                callbacktype: "jQuery"
            });
        });
        this.place.off('click.opentutorial').on('click.opentutorial', '.opentutorial', function (event) {
            event.stopPropagation();
            notebookSelf.openTutorial("notebook-tutorial", "notebook-4fnotes-tutorial");
        });
        this.place.off('click.opencheckertutorial').on('click.opencheckertutorial', '.opencheckertutorial', function (event) {
            event.stopPropagation();
            notebookSelf.openTutorial("checker-tutorial", "notebook-4fnotes-0");
        });
        this.place.off('addnotebookinit.ready').on('addnotebookinit.ready', function(e, e_data) {
            if (typeof(e_data.detail) !== "undefined"){
                e_data = e_data.detail;
            };
            /* error 12 is EULA and 13 is servicetime expired
            *  we want that user can still make new notebooks
            *  even without service.
            *  NOTE: this may create a problem then when user
            *        renew service subscription
            */
            // if(!e_data.success && (e_data.errortype == 12 || e_data.errortype == 13) ){
            if (!e_data.success && (e_data.errortype == 12) ){
                notebookSelf.place.trigger(e_data.localizableerror+'_error');
                return false;
            };
            if (!e_data.serverdata) {
                notebookSelf.openSelectDialog(e_data);
            } else {
                notebookSelf.setDataSelectDialog(e_data);
            };
        });
        this.place.off('createNewContent.notebooks').on('createNewContent.notebooks', function(e,e_data) {
            var currenttime = new Date();
            var bookid= e_data.filename.replace(/\.json$/,"");
            var new_data = {
                "metadata":{
                    "creator": e_data.username,
                    "created": currenttime.toString()
                },
                "data":{
                    "bookid": bookid,
                    "title":{
                        "common": notebookSelf.sanitize(e_data.title)
                    },
                    "defaultlang": notebookSelf.config.general.uilang,
                    "langs": [notebookSelf.config.general.uilang],
                },
                "name": bookid
            };
            new_data.data.title[notebookSelf.config.general.uilang] = notebookSelf.sanitize(e_data.title);
            new_data =jQuery.extend(true, {}, notebookSelf.defaultnew, new_data);
            var contentdata = {
                "appdata": {

                },
                "materialdata": {

                },
                "storage": {},
                "storageparts": [],
                "updateparts": {}
            };
            contentdata.materialdata[bookid] = new_data;
            var groups = {};
            groups[e_data.filename + "own"] = {
                description: 'Ownergroup',
                optional_role: null,
                groupid: e_data.filename + "own",
                gid: e_data.filename + "own",
                tags: ['ownergroup'],
                members: [e_data.username]
            };
            var contextrights = {"edit":{"sharecontent":[{"whoid":e_data.filename+"own","whotype":"group"}],"notebookcontent":[{"whoid":e_data.filename+"own","whotype":"group"}],"message":[{"whoid":e_data.filename+"own","whotype":"group"}],"solution":[{"whoid":e_data.filename+"own","whotype":"group"}],"review":[{"whoid":e_data.filename+"own","whotype":"group"}],"booknote":[{"whoid":e_data.filename+"own","whotype":"group"}],"marginnote":[{"whoid":e_data.filename+"own","whotype":"group"}]},"publish":{"notebookcontent":[{"whoid":e_data.filename+"own","whotype":"group","toid":"context","totype":"context"}],"message":[{"whoid":e_data.filename+"own","whotype":"group","toid":e_data.filename+"own","totype":"group"},{"whoid":e_data.filename+"own","whotype":"group","toid":e_data.filename+"own","totype":"group","tomembers":true}],"solution":[{"whoid":e_data.filename+"own","whotype":"group","toid":e_data.filename+"own","totype":"group"}],"review":[{"whoid":e_data.filename+"own","whotype":"group","toid":e_data.filename+"own","totype":"group","tomembers":true}]},"elementclasses":{"general":[{"whoid":e_data.filename+"own","whotype":"group"}],"math":[{"whoid":e_data.filename+"own","whotype":"group"}],"media":[{"whoid":e_data.filename+"own","whotype":"group"}],"programming":[{"whoid":e_data.filename+"own","whotype":"group"}],"container":[{"whoid":e_data.filename+"own","whotype":"group"}],"action":[{"whoid":e_data.filename+"own","whotype":"group"}],"lists":[{"whoid":e_data.filename+"own","whotype":"group"}],"assignments":[{"whoid":e_data.filename+"own","whotype":"group"}]}};


            var groupkey = Math.random().toString(36).replace(/^0\./,'');
            var datainfo ={
                "type": "own_notes",
                "serversync": false,
                "contexttype": "own_notes",
                "titles": {
                    "common": notebookSelf.sanitize(e_data.title)
                },
                "id": e_data.filename.replace(/\.json$/,""),
                "filename": e_data.filename,
                "metadata": {
                    "timestamp": currenttime,
                    "creator": e_data.username
                },
                "material": [
                    {
                        type: 'notebook',
                        jq: 'notebookview',
                        id: bookid
                    }
                ],
                "apps": [
                    {
                        "type": "marginnotes",
                        "jq": "marginnotes",
                        "id": "marginnotes-" + bookid
                    },
                    {
                        "type": "sharer",
                        "jq": "sharertool",
                        "id": "sharer-" + bookid
                    }
                ],
                "users": [e_data.user],
                "groups": function() {var retlist = []; for (let i in groups) {retlist.push(groups[i])}; return retlist;}(),
                "rights": contextrights,
                "createdata": {
                    contentdata : contentdata,
                    savetype    : "objtofiles",
                    contenttype : "own_notes",
                    contextid   : e_data.filename,
                },
                "contentid": bookid,
                "contextid": bookid,
            };
            datainfo.titles[notebookSelf.config.general.uilang] = notebookSelf.sanitize(e_data.title);

            notebookSelf.place.trigger('createNewContent.system', {
                application: "notebooks",
                type: "notebooks",
                contexttype : "own_notes",
                contextid   : e_data.filename,
                event: "contentCreated.notebooks",
                filename: e_data.filename,
                info: datainfo,
                newcontent: {
                    contentdata : contentdata,
                    savetype    : "objtofiles",
                    contenttype : "own_notes",
                    contexttype : "own_notes",
                    contextid   : e_data.filename,
                },
                serverdata: {
                    contexttype : 'own_notes',
                    contextid : e_data.filename,
                    data: JSON.stringify(jQuery.extend(true, {}, datainfo,{serversync: true})),
                    timestamp: currenttime,
                    name : notebookSelf.sanitize(e_data.title),
                    short_desc : null,
                    description : null,
                    pubtype : 'group',
                    public_to: null,
                    create_groups : groups,
                    keys_to_groups : [{value: groupkey, groups : [e_data.filename + "own"]}],
                    rights: contextrights,
                    join_groups: [e_data.filename + "own"]
                }
            });
        });
        this.place.off('importContent.notebooks').on('importContent.notebooks', function(e,e_data) {
            notebookSelf.place.trigger('importContent.system', {
                application: "notebooks",
                type: "own_notes",
                filetype: "json",
                updatetype: "own_notes",
                event: "contentCreated.notebooks",
                content: e_data.contentinfos
            });

        });
        this.place.off('clearDialog.notebooks').on('clearDialog.notebooks', function(e,e_data) {
            jQuery.modal.close();
            notebookSelf.place.trigger('refreshview.notebooks');
        });
        this.place.off('refreshview.notebooks').on('refreshview.notebooks', function() {
            notebookSelf.place.empty();
            notebookSelf.place.off();
            notebookSelf.place.notebooks(notebookSelf.initParams);
        });
    };

    /**
     * Open notebook
     */
    Notebooks.prototype.openNotebook = function(contextid) {
        var plugindata = {
            parameters: {
                contenttype: 'own_notes',
                contentid: contextid,
                contexttype: 'own_notes',
                contextid: contextid
            },
            plugins: [
                {
                    pluginName: 'notebook',
                    params: {
                        systemRequests: [
                            {
                                type: 'getContentAsObject',
                                getContentAsObject: {
                                    category: 'content',
                                    type: 'own_notes',
                                    context: {
                                        contextid: contextid,
                                        contexttype: 'own_notes'
                                    },
                                    filename: contextid
                                },
                                callbackEvent: 'notebookdataReady',
                                relayParams: {
                                    contentId: contextid,
                                    bookid: contextid
                                }
                            }
                        ],
                        contentInfo: {
                            contentType: 'own_notes',
                            contentFile: contextid
                        },
                        menu: []
                    }
                }
            ],
            windowAddons: {},
            menu: [{
                label: this.config.localizer.localize('Notebooks:file'),
                submenu: [
                    {label: this.config.localizer.localize('Notebooks:print_page'), click: 'printPage'}
                ]
            }]
        };
        this.place.trigger('startPlugin.system', plugindata);
    };

    /**
     * Open book selector dialog
     */
    Notebooks.prototype.openSelectDialog = function(options) {
        this.dialog = new NotebookSelectDialog(this.place, options, this.config);
        this.dialog.show();
    };

    /**
     * Fill the data on select dialog
     * @param {Object} options   The data for select dialog
     */
    Notebooks.prototype.setDataSelectDialog = function(options) {
        this.dialog.setOptions(options);
        this.dialog.init();
        this.dialog.updateContainer();
    };

    /******
     * Notebook selector
     * TODO:
     ******/
    Notebooks.prototype.addBookSelector = function(fileRef, appPlace) {
        if (fileRef.error) {
            jQuery('body').trigger('content_error', {"errorIn": "notebooksApp", "errorType": "fileError", "errorMsg": fileRef.error});
            return false;//info.json file has information about error
        };
        var bookname = this.sanitize(fileRef.titles && fileRef.titles[this.config.general.uilang] ? fileRef.titles[this.config.general.uilang] : (fileRef.titles && fileRef.titles['common'] ? fileRef.titles['common'] : fileRef.filename));
        var subjecticon = '', subject;
        if (fileRef.subjects && fileRef.subjects.length > 0) {
            subject = this.subjects[fileRef.subjects[0]];
            subjecticon = `<div class="contentitemsubjecticon">${subject.icon || ''}</div>`
        };
        var selector = `<span class="notebookSelector contentSelector" contexttype="own_notes" contextid="${fileRef.contextid}" fileRef="${fileRef.filename}" title="${bookname}">${subjecticon}<span class="contentname bookname">${bookname}</span></span>`;
        if (typeof(appPlace) !== "undefined"){
            appPlace.append(selector);
        } else {
            this.place.append(selector);
        };
    };

    //Notebooks.prototype.addNotebookShow = function(dialog,Noteself) {
    //    dialog.container.on("change",'div.servernotebooks input[type="checkbox"]',function(e){
    //        if(dialog.container.find('div.servernotebooks input[type="checkbox"]:checked').length){
    //            dialog.container.trigger('disable_choice',{"elementclass":"addnotebook"}).trigger('enable_ok');
    //        }else{
    //            dialog.container.trigger('enable_choice',{"elementclass":"addnotebook"}).trigger('disalbe_ok');
    //        }
    //    });
    //    dialog.container.on("keyup",'input[type="text"]',function(e){
    //        var inputvalue = jQuery(this).val();
    //        if(inputvalue !== ""){
    //            if(e.keyCode ===13){
    //                dialog.container.find('.dialogButtons .ok-button').click();
    //            }else{
    //                dialog.container.trigger('disable_choice',{"elementclass":"servernotebooks"}).trigger('enable_ok');
    //            }
    //        }else{
    //            dialog.container.trigger('clear_notValidName').trigger('enable_choice',{"elementclass":"servernotebooks"}).trigger('disalbe_ok');
    //        }
    //    });
    //    dialog.container.on("notValidName",function(){
    //        dialog.container.find('input[type="text"]').addClass('notvalidname').css('background-color','light-red');
    //    });
    //    dialog.container.on("clear_notValidName",function(){
    //        dialog.container.find('input[type="text"]').removeClass('notvalidname').css('background-color','white');
    //    });
    //    dialog.container.on("enable_ok",function(){
    //        dialog.container.find('.ok-button').removeClass('buttondisabled');
    //    });
    //    dialog.container.on("disalbe_ok",function(){
    //        dialog.container.find('.ok-button').addClass('buttondisabled');
    //    });
    //    dialog.container.on("enable_choice",function(e,e_data){
    //        dialog.container.find('.ok-button').addClass('buttondisabled');
    //    });
    //    dialog.container.on("disable_choice",function(e,e_data){
    //        dialog.container.find('div.'+e_data.elementclass).addClass('elementdisable').find('input').prop('disabled',true);
    //    });
    //    dialog.container.on("enable_choice",function(e,e_data){
    //        dialog.container.find('div.'+e_data.elementclass).removeClass('elementdisable').find('input').prop('disabled',false);
    //    });
    //    dialog.container.on("click",".ok-button",function(){
    //        var inputvalue = dialog.container.find('input[type="text"]').val();
    //        if(jQuery(this).hasClass('buttondisabled'))return false;
    //        if(inputvalue !== ""){
    //            Noteself.place.trigger('createNewContent.notebooks',
    //                {
    //                    title:dialog.container.find('input[type="text"]').val(),
    //                    user:{
    //                        username:dialog.container.find('div.addnotebook').attr('data-username'),
    //                        realname:{
    //                            firstname:dialog.container.find('div.addnotebook').attr('data-firstname'),
    //                            lastname:dialog.container.find('div.addnotebook').attr('data-lastname')
    //                        }
    //                    },
    //                    username:dialog.container.find('div.addnotebook').attr('data-username'),
    //                    filename:dialog.container.find('div.addnotebook').attr('data-filename')
    //                });                
    //        }else{
    //            var servercontentinfos = [];
    //            var imports = dialog.container.find('div.servernotebooks input[type="checkbox"]:checked');
    //            for(var i=0;i<imports.length;i++){
    //                servercontentinfos.push(JSON.parse(imports.eq(i).closest('li').find('.oneserverbookdata').text()));
    //            }
    //            Noteself.place.trigger('importContent.notebooks',{contentinfos: servercontentinfos});
    //        }
    //        
    //    });
    //}

    /**
     * Get the guided tour for courses.
     * @returns {Object} The guided tour
     */
    Notebooks.prototype.getGuidedTour = function() {
        var tour = {
            id: 'notebooktour',
            autostart: true,
            items: [
                {
                    id: 'notebook_select',
                    selector: '#applicationControl > .notebooks .contentSelector.newcontentSelector, #applicationControl > .notebooks .applicationButton.addnotebook',
                    side: 'up',
                    position: 'start',
                    title: {
                        en: 'Create or download',
                        sv: 'Skapa eller ladda ner',
                        fi: 'Luo tai lataa'
                    },
                    message: {
                        en: 'New notebook is created or old one is downloaded from the server by clicking the "plus"-icon.',
                        sv: 'Du kan skapa en ny anteckningsbok eller ladda ner en tidigare anteckningsbok genom att klicka på "plus"-ikonen.',
                        fi: 'Uusi muistivihko luodaan tai olemassa oleva ladataan palvelimelta klikkaamalla "plus"-kuvaketta.'
                    },
                    enter: [
                        {
                            selector: '#applicationControl > .notebooks',
                            event: 'scrollintoview'
                        },
                        {
                            selector: '#applicationControl > .notebooks .contentSelector.newcontentSelector',
                            event: 'scrollintoview'
                        }
                    ],
                    leave: []
                },
                {
                    id: 'notebook_create',
                    selector: '#simplemodal-data .addnotebook .notebooktitle',
                    side: 'right',
                    position: 'center',
                    title: {
                        en: 'Add notebook',
                        sv: 'Lägg till en anteckningsbok',
                        fi: 'Lisää vihko'
                    },
                    message: {
                        en: 'If you want to create a new notebook, write the title for it and click OK.',
                        sv: 'När du vill skapa en ny anteckningsbok, så skriv titeln för den och klicka OK.',
                        fi: 'Jos haluat luoda uuden vihon, kirjoita sen otsikko ja klikkaa OK.'
                    },
                    enter: [
                        {
                            selector: '#applicationControl > .notebooks .contentSelector.newcontentSelector, #applicationControl > .notebooks .applicationButton.addnotebook',
                            event: 'click'
                        }
                    ],
                    leave: [
                        {
                            selector: '.modal-close.simplemodal-close',
                            event: 'click'
                        }
                    ]
                },
                {
                    id: 'notebook_create',
                    selector: '#simplemodal-data .servernotebooks .serverdatalist',
                    side: 'up',
                    position: 'center',
                    title: {
                        en: 'Select existing notebook',
                        sv: 'Välj en existerande anteckningsbok',
                        fi: 'Valitse olemassa oleva vihko'
                    },
                    message: {
                        en: 'If you have existing notebooks on the server, select what you want from the list and click OK. Downloading might again take some time, if the notebook is big.',
                        sv: 'Om du har anteckningsböcker på servern, så välj den du vill ha från förteckningen och klicka OK. Nedladdningen kan igen ta en liten tid, om anteckningsboken har mycket material i sig.',
                        fi: 'Jos sinulla on jo vihkoja palvelimella, valitse listasta se, jonka haluat ladata ja klikkaa OK. Lataaminen voi kestää hetken, jos vihko on suuri.'
                    },
                    enter: [
                        {
                            selector: '#applicationControl > .notebooks .contentSelector.newcontentSelector, #applicationControl > .notebooks .applicationButton.addnotebook',
                            event: 'click'
                        }
                    ],
                    leave: [
                        {
                            selector: '.modal-close.simplemodal-close',
                            event: 'click'
                        }
                    ]
                },
                {
                    id: 'notebook_open',
                    selector: '#applicationControl > .notebooks .contentSelector',
                    side: 'up',
                    position: 'start',
                    title: {
                        en: 'Opening a notebook',
                        sv: 'Öppna en anteckningsbok',
                        fi: 'Vihon avaaminen'
                    },
                    message: {
                        en: 'Notebooks on this computer are listed as notebook icons. Clicking one opens the notebook.',
                        sv: 'Anteckningsböckerna på den här datorn visas som ikoner. Klicka på en ikon så öppnar den anteckningsboken.',
                        fi: 'Tällä laitteella olevat vihot on lueteltu muistikirjakuvakkeina. Kuvakkeen klikkaaminen avaa vihon.'
                    },
                    enter: [
                        {
                            selector: '#applicationControl > .notebooks',
                            event: 'scrollintoview'
                        },
                        {
                            selector: '#applicationControl > .notebooks .contentSelector',
                            event: 'scrollintoview'
                        }
                    ],
                    leave: [
                    ]
                },
                {
                    id: 'notebook_tutorial',
                    selector: '#applicationControl > .notebooks .applicationButton.opentutorial',
                    side: 'up',
                    position: 'start',
                    title: {
                        en: 'Notebook tutorial',
                        sv: 'Tutorial för anteckningsboken',
                        fi: 'Vihkotutoriaali'
                    },
                    message: {
                        en: 'You can learn how to use the notebooks by opening the tutorial. The tutorial tells, how the system works, shows you some examples and lets you try by your self. You can freely try and edit everything in the tutorial, since it does not save changes.',
                        sv: 'Du kan lära dig hur man använder anteckningsböckerna genom att öppna tutorialen. Tutorialen beskriver hur systemet fungerar, visar några exempel, och låter dig själv jobba i atenckingsboken. Du kan fritt pröva dig fram och editera vad som helst i tutorialen, eftersom den inte sparar dina ändringar.',
                        fi: 'Voit opetella vihon toimintaa avaamalla tutoriaalin. Tutoriaali kertoo, miten järjestelmä toimii, näyttää sinulle joitakin esimerkkejä ja antaa sinun kokeilla itse. Voit vapaasti kokeilla ja muokata mitä tahansa tutoriaalissa, sillä muutoksia ei tallenneta.'
                    },
                    enter: [
                        {
                            selector: '#applicationControl > .notebooks',
                            event: 'scrollintoview'
                        },
                        {
                            selector: '#applicationControl > .notebooks .contentSelector',
                            event: 'scrollintoview'
                        }
                    ],
                    leave: [
                    ]
                },
                {
                    id: 'checker_tutorial',
                    selector: '#applicationControl > .notebooks .applicationButton.opencheckertutorial',
                    side: 'up',
                    position: 'end',
                    title: {
                        en: 'Automatic checking tutorial',
                        sv: 'Tutorial för den automatiska checkern',
                        fi: 'Automaattisen tarkistamisen tutoriaali'
                    },
                    message: {
                        en: 'With this tutorial you can learn how to use the automatic checking.',
                        sv: 'Du kan lära dig hur man använder den automatiska checkern genom att öppna den här tutorialen.',
                        fi: 'Tällä tutoriaalilla voit opetella automaattisen tarkistimen toimintaa.'
                    },
                    enter: [
                        {
                            selector: '#applicationControl > .notebooks',
                            event: 'scrollintoview'
                        },
                        {
                            selector: '#applicationControl > .notebooks .contentSelector',
                            event: 'scrollintoview'
                        }
                    ],
                    leave: [
                    ]
                }
            ]
        };
        return tour;
    };


    /******
     *
     ******/
    Notebooks.prototype.main = function() {
        this.place.trigger('addguidedtour', this.getGuidedTour());
        this.mainParent();
        this.showTutorialButtons();
        this.place.find('.controlpanel').append('<span class="applicationButton add-button addnotebook defaultaddbutton"><span class="buttonIcon"></span><span class="buttonText">'+this.config.localizer.localize('Notebooks:addnotebook')+'</span></span>');
    };

    Notebooks.prototype.showTutorialButtons = function() {
        this.place.find('.controlpanel').append(`
            <span class="applicationButton opentutorial">
                <span class="buttonIcon">${this.icons.tutorial}</span>
                <span class="buttonText">${this.config.localizer.localize('Notebooks:opentutorial')}</span>
            </span>
            <span class="applicationButton opencheckertutorial">
                <span class="buttonIcon">${this.icons.tutorial}</span>
                <span class="buttonText">${this.config.localizer.localize('Notebooks:opencheckertutorial')}</span>
            </span>
        `);
    };

    Notebooks.prototype.openTutorial = function(filename,contentId) {
        this.place.trigger('startTutorial.system', {
            filename: filename,
            contentId: contentId,
            plugins: [
                {
                    pluginName: 'notebook',
                    params: {
                        systemRequests: [{type: 'getContentAsObject'}]
                    }
                }
            ],
            menu: [{
                label: this.config.localizer.localize('Notebooks:file'),
                submenu: [
                    {label: this.config.localizer.localize('Notebooks:print_page'), click: 'printPage'}
                ]
            }]
        });
    };

    Notebooks.prototype.icons = {
        tutorial: '<svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="30" height="30" viewBox="0 0 30 30" class="mini-icon mini-icon-question mini-icon-help"><circle class="mini-icon-background" stroke="none" fill="none" cx="15" cy="15" r="15" /><path class="mini-icon-foreground" style="stroke: none;" d="M8 11 c2 -9 14 -8 14 0 c0 4 -5 6 -5 8 v1 h-4 v-1 c0 -4 5 -5 5 -8 c0 -3 -5 -4 -6 1z m5 11 h4 v4 h-4z"></path></svg>'
    }

    { /** jQuery Plugin interface    **/
        var methods = {
            'init' : function(params) {
                return this.each( function() {
                    var notebooks = new Notebooks($(this), params);
                    $(this).data('notebooks', notebooks);
                });
            },
            'refresh' : function() {
                return this.each( function() {
                    $(this).trigger('refreshview.notebooks');
                });
            },
            'get' : function(params) {
                return $(this).data('notebooks')[params];
            },
            'set' : function(params) {
                return $(this).data('notebooks')[params[0]] = params[1];
            }
        }

        $.fn.notebooks = function( method ) {
            if ( methods[method] ) {
                return methods[method].apply( this, Array.prototype.slice.call( arguments, 1 ));
            } else if ( typeof method === 'object' || ! method ) {
                return methods.init.apply( this, arguments );
            } else {
                $.error( 'Method ' +  method + ' does not exist.' );
                return false;
            }
        }
    }

    /**
     * Class for notebook selecting dialog
     * @class NotebookSelectDialog
     * @constructor
     * @param {jQuery} place    The place for this dialog
     * @param {Object} options  All needed options
     * @param {Object} config   The configs for the dialog
     */
    var NotebookSelectDialog = function(place, options, config) {
        this.place = place;
        this.config = config;
        this.setOptions(options);
        this.addStyles();
        this.init();
        return this;
    };

    /**
     * Set options
     * @param {Object} options   Options for select dialog
     */
    NotebookSelectDialog.prototype.setOptions = function(options) {
        this.options = $.extend(true, {}, this.defaults, this.options, options);
    };

    /**
     * Update container
     */
    NotebookSelectDialog.prototype.updateContainer = function() {
        this.container.find('#simplemodal-data').html(this.getHtml());
    };

    /**
     * Do some initing for the dialog object
     */
    NotebookSelectDialog.prototype.init = function() {
        var uilang = this.config.general.uilang;
        var localdata = this.options.localdata;
    };

    /**
     * Show the notebook selection dialog
     */
    NotebookSelectDialog.prototype.show = function() {
        var seldialog = this;
        var localizer = this.config.localizer;
        if (typeof(jQuery.modal) === 'function') {
            this.dialog = jQuery.modal(this.getHtml(), {
                closeHTML: `<a href='#' title='${localizer.localize('Bookshelf:close')}' class='modal-close'>${application.prototype.icons.close}</a>`,
                close: true,
                minHeight: this.config.dialogHeight(),
                maxHeight : this.config.dialogHeight(),
                minWidth: this.config.dialogWidth(),
                autoResize :true,
                onShow: function(dialog){},
                overlayId: undefined,
                containerId: 'notebookadd',
                escClose: false
            });
            this.container = this.dialog.d.container;
        };
        this.initHandlers();
        this.updateFiltering()
    };

    /**
     * Init the event handlers.
     */
    NotebookSelectDialog.prototype.initHandlers = function() {
        var selectdialog = this;
        var localizer = this.config.localizer;
        var dialog = this.dialog;
        var container = dialog.d.container;
        container.off('change', 'div.servernotebooks input[type="checkbox"]').on('change', 'div.servernotebooks input[type="checkbox"]', function(event) {
            event.stopPropagation();
            if (container.find('div.servernotebooks input[type="checkbox"]:checked').length > 0) {
                container.trigger('disable_choice', {elementclass: 'addnotebook'});
                selectdialog.enableOK();
            } else {
                container.trigger('enable_choice', {elementclass: 'addnotebook'});
                selectdialog.disableOK();
            };
        }).off('keyup', 'input[type="text"]').on('keyup', 'input[type="text"]', function(event) {
            event.stopPropagation();
            var inputvalue = $(this).val();
            if (inputvalue !== '') {
                if (event.keyCode === 13) {
                    container.find('.dialogButtons .ok-button').click();
                } else {
                    container.trigger('disable_choice', {elementclass: 'servernotebooks'});
                    selectdialog.enableOK();
                };
            } else {
                container.trigger('clear_notValidName').trigger('enable_choice', {elementclass: 'servernotebooks'});
                selectdialog.disableOK();
            };
        }).off('notValidName').on('notValidName', function(event) {
            event.stopPropagation();
            container.find('input[type="text"]').addClass('notvalidname').css('background-color', 'light-red');
        }).off('clear_notValidName').on('clear_notValidName', function(event) {
            event.stopPropagation();
            container.find('input[type="text"]').removeClass('notvalidname').css('background-color', 'white');
        }).off('enable_ok').on('enable_ok', function(event) {
            event.stopPropagation();
            selectdialog.enableOK();
        }).off('disable_ok').on('disable_ok', function(event) {
            event.stopPropagation();
            selectdialog.disableOK();
        }).off('disable_choice').on('disable_choice', function(event, data) {
            event.stopPropagation();
            container.find('div.' + data.elementclass).addClass('elementdisable').find('input').prop('disabled', true);
        }).off('enable_choice').on('enable_choice', function(event, data) {
            event.stopPropagation();
            container.find('div.' + data.elementclass).removeClass('elementdisable').find('input').prop('disabled', false);
        }).off('click', '.ok-button').on('click', '.ok-button', function(event) {
            event.stopPropagation();
            var inputvalue = container.find('input[type="text"]').val();
            if ($(this).is('.buttondisabled')) {
                return false;
            }
            if (inputvalue !== '') {
                selectdialog.place.off('contentCreated.notebooks').on('contentCreated.notebooks', function(e, data) {
                    if (typeof(data.detail) !== 'undefined') {
                        data = data.detail;
                    };
                    if (data.success) {
                        selectdialog.place.trigger('clearDialog.notebooks');
                    } else {
                        container.trigger('registrationerror', {msg: 'registration error'});
                        selectdialog.place.trigger('clearDialog.notebooks');
                    };
                    selectdialog.place.off('contentCreated.notebooks');
                });
                selectdialog.place.trigger('createNewContent.notebooks', {
                    title: inputvalue,
                    user: {
                        username: selectdialog.config.user.username,
                        realname: {
                            firstname: selectdialog.config.user.firstname,
                            lastname: selectdialog.config.user.lastname
                        }
                    },
                    username: selectdialog.config.user.username,
                    filename: container.find('div.addnotebook').attr('data-filename')
                });
            } else {
                selectdialog.place.off('contentCreated.notebooks').on('contentCreated.notebooks', function(e, data) {
                    if (typeof(data.detail) !== 'undefined') {
                        data = data.detail;
                    };
                    if (data.success) {
                        selectdialog.place.trigger('clearDialog.notebooks');
                    } else {
                        container.trigger('registrationerror', {msg: 'registration error'});
                        selectdialog.place.trigger('clearDialog.notebooks');
                    };
                    selectdialog.place.off('contentCreated.notebooks');
                });
                let servercontentinfos = [];
                let imports = container.find('div.servernotebooks input[type="checkbox"]:checked').closest('li.oneserverbook');
                for (let i = 0, len = imports.length; i < len; i++) {
                    let index = imports.eq(i).attr('data-listindex');
                    let serverData = selectdialog.options.serverdata && selectdialog.options.serverdata[index] || {};
                    servercontentinfos.push(serverData);
                };
                selectdialog.place.trigger('importContent.notebooks', {contentinfos: servercontentinfos});
                container.append(`<div style="position:absolute;top:0;bottom:0;right:0;left:0;padding:100px;background-color:rgba(255,255,255,0.5);z-index:10;text-align: center;">
                        <div>Loading...</div>
                        <div>${application.prototype.icons.waitdots}</div>
                    </div>
                `);
            };
        });
    };

    /**
     * Enable ok-button
     */
    NotebookSelectDialog.prototype.enableOK = function() {
        this.dialog.d.container.find('.ok-button').removeClass('buttondisabled');
    };

    /**
     * Disable ok-button
     */
    NotebookSelectDialog.prototype.disableOK = function() {
        this.dialog.d.container.find('.ok-button').addClass('buttondisabled');
    };

    /**
     * Update filtering
     */
    NotebookSelectDialog.prototype.updateFiltering = function() {

    }

    /**
     * Get the html-code for the dialog.
     */
    NotebookSelectDialog.prototype.getHtml = function() {
        var options = this.options;
        var localizer = this.config.localizer;
        var dialogHTML = `
            <h1>${localizer.localize('Notebooks:addnotebook')}</h1>
            <div class="addnotebook" data-firstname="${sanitize(options.localdata.firstname)}" data-lastname="${sanitize(options.localdata.lastname)}" data-username="${sanitize(options.localdata.username)}" data-filename="${sanitize(options.localdata.filename)}">
                <h4>${localizer.localize('Notebooks:addnewnotebook')}</h4>
                <label>${localizer.localize('Notebooks:notebookstitle')}: <input class="notebooktitle" type="text"></label>
            </div>
        `;
        if (options.serverdata && typeof(options.serverdata.length) === 'number') {
            dialogHTML += `
            <div class="servernotebooks">
                <h4>${localizer.localize('Notebooks:serverimport')}</h4>
                <ul class="serverdatalist">
                ${this.getServerDataList()}
                </ul>
            </div>
            <div class="buttons dialogButtons">
                <span class="applicationButton ok-button buttondisabled">OK</span></div>
            </div>
            `
        } else {
            dialogHTML += `
            <div class="servernotebooks">
                <h4>${localizer.localize('Notebooks:serverimport')}</h4>
                <ul class="serverdatalist">
                    <li class="oneserverbook" style="text-align: center;">${application.prototype.icons.waitdots}</li>
                </ul>
            </div>
            `;
        };
        return dialogHTML;
    };

    /**
     * Get the list of server datas
     */
    NotebookSelectDialog.prototype.getServerDataList = function() {
        var bookshelf = this;
        var html = [], titles;
        var uilang = this.config.general.uilang;
        var serverdata = this.options.serverdata || [];
        var cdata;
        serverdata.sort(function(a, b) {
            var titlesA, titlesB, titleA = '', titleB = '';
            try {
                titlesA = JSON.parse(a.data).titles;
                titlesB = JSON.parse(b.data).titles;
                titleA = titlesA[uilang] || titlesA['common'];
                titleB = titlesB[uilang] || titlesB['common'];
            } catch (err) {
                console.log(err);
                return -1;
            }
            return (titleA < titleB ? -1 : ((titleB < titleA) ? 1 : 0));
        });
        for (let i = 0, len = serverdata.length; i < len; i++) {
            cdata = JSON.parse(serverdata[i].data);
            titles = cdata.titles || {fi: 'otsikko', en: 'title', sv: 'rubrik'};
            html.push(`
                <li class="oneserverbook" data-listindex="${i}">
                    <label>
                        ${sanitize(titles[uilang] || titles['common'])}
                        <input type="checkbox">
                    </label>
                </li>
            `);
        };
        return html.join('\n');
    };

    /**
     * Add styles for notebook select dialog
     */
    NotebookSelectDialog.prototype.addStyles = function() {
        if ($('head style#notebookaddcss').length === 0) {
            $('head').append(`
                <style id="notebookaddcss" type="text/css">
                
                </style>
            `);
        };
    };

    /**
     * Defaults for book select dialog
     */
    NotebookSelectDialog.prototype.defaults = {

    }

    /**
     * Use the sanitizer of the Notebooks-class.
     */
    var sanitize = Notebooks.prototype.sanitize;

})(jQuery)